Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.vecmath
Class Matrix4f

    java.lang.Object
      javax.vecmath.Matrix4f

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class Matrix4f

extends java.lang.Object
implements java.io.Serializable, java.lang.Cloneable

A single precision floating point 4 by 4 matrix. Primarily to support 3D rotations.

See Also:
  Serialized Form

Field Summary
`float` | `m00` The first element of the first row.
`float` | `m01` The second element of the first row.
`float` | `m02` The third element of the first row.
`float` | `m03` The fourth element of the first row.
`float` | `m10` The first element of the second row.
`float` | `m11` The second element of the second row.
`float` | `m12` The third element of the second row.
`float` | `m13` The fourth element of the second row.
`float` | `m20` The first element of the third row.
`float` | `m21` The second element of the third row.
`float` | `m22` The third element of the third row.
`float` | `m23` The fourth element of the third row.
`float` | `m30` The first element of the fourth row.
`float` | `m31` The second element of the fourth row.
`float` | `m32` The third element of the fourth row.
`float` | `m33` The fourth element of the fourth row.

Constructor Summary
`Matrix4f()` Constructs and initializes a Matrix4f to all zeros.
`Matrix4f(float[] v)` Constructs and initializes a Matrix4f from the specified 16 element array.
`Matrix4f(float m00, float m01, float m02, float m03, float m10, float m11, float m12, float m13, float m20, float m21, float m22, float m23, float m30, float m31, float m32, float m33)` Constructs and initializes a Matrix4f from the specified 16 values.
`Matrix4f(Matrix3f m1, Vector3f t1, float s)` Constructs and initializes a Matrix4f from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components of the matrix.
`Matrix4f(Matrix4d m1)` Constructs a new matrix with the same values as the Matrix4d parameter.
`Matrix4f(Matrix4f m1)` Constructs a new matrix with the same values as the Matrix4f parameter.
`Matrix4f(Quat4f q1, Vector3f t1, float s)` Constructs and initializes a Matrix4f from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

Method Summary
`void` | `add(float scalar)` Adds a scalar to each component of this matrix.
`void` | `add(float scalar, Matrix4f m1)` Adds a scalar to each component of the matrix m1 and places the result into this.
`void` | `add(Matrix4f m1)` Sets the value of this matrix to the sum of itself and matrix m1.
`void` | `add(Matrix4f m1, Matrix4f m2)` Sets the value of this matrix to the matrix sum of matrices m1 and m2.
`java.lang.Object` | `clone()` Creates a new object of the same class as this object.
`float` | `determinant()` Computes the determinate of this matrix.
`boolean` | `epsilonEquals(Matrix4f m1, float epsilon)` Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false.
`boolean` | `equals(Matrix4f m1)` Returns true if all of the data members of Matrix4f m1 are equal to the corresponding data members in this Matrix4f.
`boolean` | `equals(java.lang.Object t1)` Returns true if the Object t1 is of type Matrix4f and all of the data members of t1 are equal to the corresponding data members in this Matrix4f.
`void` | `get(Matrix3d m1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3d parameter.
`void` | `get(Matrix3f m1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3f parameter.
`float` | `get(Matrix3f m1, Vector3f t1)` Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale.
`void` | `get(Quat4f q1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Quat4f parameter.
`void` | `get(Vector3f trans)` Retrieves the translational components of this matrix.
`void` | `getColumn(int column, float[] v)` Copies the matrix values in the specified column into the array parameter.
`void` | `getColumn(int column, Vector4f v)` Copies the matrix values in the specified column into the vector parameter.
`float` | `getElement(int row, int column)` Retrieves the value at the specified row and column of this matrix.
`float` | `getM00()` Get the first matrix element in the first row.
`float` | `getM01()` Get the second matrix element in the first row.
`float` | `getM02()` Get the third matrix element in the first row.
`float` | `getM03()` Get the fourth element of the first row.
`float` | `getM10()` Get first matrix element in the second row.
`float` | `getM11()` Get second matrix element in the second row.
`float` | `getM12()` Get the third matrix element in the second row.
`float` | `getM13()` Get the fourth element of the second row.
`float` | `getM20()` Get the first matrix element in the third row.
`float` | `getM21()` Get the second matrix element in the third row.
`float` | `getM22()` Get the third matrix element in the third row.
`float` | `getM23()` Get the fourth element of the third row.
`float` | `getM30()` Get the first element of the fourth row.
`float` | `getM31()` Get the second element of the fourth row.
`float` | `getM32()` Get the third element of the fourth row.
`float` | `getM33()` Get the fourth element of the fourth row.
`void` | `getRotationScale(Matrix3f m1)` Gets the upper 3x3 values of this matrix and places them into the matrix m1.
`void` | `getRow(int row, float[] v)` Copies the matrix values in the specified row into the array parameter.
`void` | `getRow(int row, Vector4f v)` Copies the matrix values in the specified row into the vector parameter.
`float` | `getScale()` Performs an SVD normalization of this matrix to calculate and return the uniform scale factor.
`int` | `hashCode()` Returns a hash code value based on the data values in this object.
`void` | `invert()` Inverts this matrix in place.
`void` | `invert(Matrix4f m1)` Sets the value of this matrix to the matrix inverse of the passed (user declared) matrix m1.
`void` | `mul(float scalar)` Multiplies each element of this matrix by a scalar.
`void` | `mul(float scalar, Matrix4f m1)` Multiplies each element of matrix m1 by a scalar and places the result into this.
`void` | `mul(Matrix4f m1)` Sets the value of this matrix to the result of multiplying itself with matrix m1.
`void` | `mul(Matrix4f m1, Matrix4f m2)` Sets the value of this matrix to the result of multiplying the two argument matrices together.
`void` | `mulTransposeBoth(Matrix4f m1, Matrix4f m2)` Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `mulTransposeLeft(Matrix4f m1, Matrix4f m2)` Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.
`void` | `mulTransposeRight(Matrix4f m1, Matrix4f m2)` Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `negate()` Negates the value of this matrix: this = -this.
`void` | `negate(Matrix4f m1)` Sets the value of this matrix equal to the negation of of the Matrix4f parameter.
`void` | `rotX(float angle)` Sets the value of this matrix to a counter clockwise rotation about the x axis.
`void` | `rotY(float angle)` Sets the value of this matrix to a counter clockwise rotation about the y axis.
`void` | `rotZ(float angle)` Sets the value of this matrix to a counter clockwise rotation about the z axis.
`void` | `set(AxisAngle4d a1)` Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.
`void` | `set(AxisAngle4f a1)` Sets the value of this matrix to the matrix conversion of the (single precision) axis and angle argument.
`void` | `set(float scale)` Sets the value of this matrix to a scale matrix with the the passed scale amount.
`void` | `set(float[] m)` Sets the values in this Matrix4f equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).
`void` | `set(float scale, Vector3f t1)` Sets the value of this transform to a scale and translation matrix; the scale is not applied to the translation and all of the matrix values are modified.
`void` | `set(Matrix3d m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).
`void` | `set(Matrix3d m1, Vector3d t1, double scale)` Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor.
`void` | `set(Matrix3f m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).
`void` | `set(Matrix3f m1, Vector3f t1, float scale)` Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor.
`void` | `set(Matrix4d m1)` Sets the value of this matrix to the float value of the passed matrix4d m1.
`void` | `set(Matrix4f m1)` Sets the value of this matrix to a copy of the passed matrix m1.
`void` | `set(Quat4d q1)` Sets the value of this matrix to the matrix conversion of the double precision quaternion argument.
`void` | `set(Quat4d q1, Vector3d t1, double s)` Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.
`void` | `set(Quat4f q1)` Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.
`void` | `set(Quat4f q1, Vector3f t1, float s)` Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.
`void` | `set(Vector3f v1)` Sets the value of this matrix to a translate matrix with the passed translation value.
`void` | `set(Vector3f t1, float scale)` Sets the value of this transform to a scale and translation matrix; the translation is scaled by the scale factor and all of the matrix values are modified.
`void` | `setColumn(int column, float[] v)` Sets the specified column of this matrix4f to the four values provided.
`void` | `setColumn(int column, float x, float y, float z, float w)` Sets the specified column of this matrix4f to the four values provided.
`void` | `setColumn(int column, Vector4f v)` Sets the specified column of this matrix4f to the vector provided.
`void` | `setElement(int row, int column, float value)` Sets the specified element of this matrix4f to the value provided.
`void` | `setIdentity()` Sets this Matrix4f to identity.
`void` | `setM00(float m00)` Set the first matrix element in the first row.
`void` | `setM01(float m01)` Set the second matrix element in the first row.
`void` | `setM02(float m02)` Set the third matrix element in the first row.
`void` | `setM03(float m03)` Set the fourth element of the first row.
`void` | `setM10(float m10)` Set first matrix element in the second row.
`void` | `setM11(float m11)` Set the second matrix element in the second row.
`void` | `setM12(float m12)` Set the third matrix element in the second row.
`void` | `setM13(float m13)` Set the fourth element of the second row.
`void` | `setM20(float m20)` Set the first matrix element in the third row.
`void` | `setM21(float m21)` Set the second matrix element in the third row.
`void` | `setM22(float m22)` Set the third matrix element in the third row.
`void` | `setM23(float m23)` Set the fourth element of the third row.
`void` | `setM30(float m30)` Set the first element of the fourth row.
`void` | `setM31(float m31)` Set the second element of the fourth row.
`void` | `setM32(float m32)` Set the third element of the fourth row.
`void` | `setM33(float m33)` Set the fourth element of the fourth row.
`void` | `setRotation(AxisAngle4f a1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the axis-angle argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the axis-angle, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Matrix3d m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Matrix3f m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Quat4d q1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Quat4f q1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.
`void` | `setRotationScale(Matrix3f m1)` Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.
`void` | `setRow(int row, float[] v)` Sets the specified row of this matrix4f to the four values provided in the passed array.
`void` | `setRow(int row, float x, float y, float z, float w)` Sets the specified row of this matrix4f to the four values provided.
`void` | `setRow(int row, Vector4f v)` Sets the specified row of this matrix4f to the Vector provided.
`void` | `setScale(float scale)` Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.
`void` | `setTranslation(Vector3f trans)` Modifies the translational components of this matrix to the values of the Vector3f argument; the other values of this matrix are not modified.
`void` | `setZero()` Sets this matrix to all zeros.
`void` | `sub(Matrix4f m1)` Sets this matrix to the matrix difference of itself and matrix m1 (this = this - m1).
`void` | `sub(Matrix4f m1, Matrix4f m2)` Performs an element-by-element subtraction of matrix m2 from matrix m1 and places the result into matrix this (this = m2 - m1).
`java.lang.String` | `toString()` Returns a string that contains the values of this Matrix4f.
`void` | `transform(Point3f point)` Transforms the point parameter with this Matrix4f and places the result back into point.
`void` | `transform(Point3f point, Point3f pointOut)` Transforms the point parameter with this Matrix4f and places the result into pointOut.
`void` | `transform(Tuple4f vec)` Transform the vector vec using this Transform and place the result back into vec.
`void` | `transform(Tuple4f vec, Tuple4f vecOut)` Transform the vector vec using this Matrix4f and place the result into vecOut.
`void` | `transform(Vector3f normal)` Transforms the normal parameter by this transform and places the value back into normal.
`void` | `transform(Vector3f normal, Vector3f normalOut)` Transforms the normal parameter by this Matrix4f and places the value into normalOut.
`void` | `transpose()` Sets the value of this matrix to its transpose in place.
`void` | `transpose(Matrix4f m1)` Sets the value of this matrix to the transpose of the argument matrix.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### m00

    public float m00

  The first element of the first row.

### m01

    public float m01

  The second element of the first row.

### m02

    public float m02

  The third element of the first row.

### m03

    public float m03

  The fourth element of the first row.

### m10

    public float m10

  The first element of the second row.

### m11

    public float m11

  The second element of the second row.

### m12

    public float m12

  The third element of the second row.

### m13

    public float m13

  The fourth element of the second row.

### m20

    public float m20

  The first element of the third row.

### m21

    public float m21

  The second element of the third row.

### m22

    public float m22

  The third element of the third row.

### m23

    public float m23

  The fourth element of the third row.

### m30

    public float m30

  The first element of the fourth row.

### m31

    public float m31

  The second element of the fourth row.

### m32

    public float m32

  The third element of the fourth row.

### m33

    public float m33

  The fourth element of the fourth row.

Constructor Detail

### Matrix4f

    public Matrix4f(float m00,
                    float m01,
                    float m02,
                    float m03,
                    float m10,
                    float m11,
                    float m12,
                    float m13,
                    float m20,
                    float m21,
                    float m22,
                    float m23,
                    float m30,
                    float m31,
                    float m32,
                    float m33)

  Constructs and initializes a Matrix4f from the specified 16 values.

  Parameters:
    `m00` - the [0][0] element
    `m01` - the [0][1] element
    `m02` - the [0][2] element
    `m03` - the [0][3] element
    `m10` - the [1][0] element
    `m11` - the [1][1] element
    `m12` - the [1][2] element
    `m13` - the [1][3] element
    `m20` - the [2][0] element
    `m21` - the [2][1] element
    `m22` - the [2][2] element
    `m23` - the [2][3] element
    `m30` - the [3][0] element
    `m31` - the [3][1] element
    `m32` - the [3][2] element
    `m33` - the [3][3] element

### Matrix4f

    public Matrix4f(float[] v)

  Constructs and initializes a Matrix4f from the specified 16 element array. this.m00 =v[0], this.m01=v[1], etc.

  Parameters:
    `v` - the array of length 16 containing in order

### Matrix4f

    public Matrix4f(Quat4f q1,
                    Vector3f t1,
                    float s)

  Constructs and initializes a Matrix4f from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

  Parameters:
    `q1` - the quaternion value representing the rotational component
    `t1` - the translational component of the matrix
    `s` - the scale value applied to the rotational components

### Matrix4f

    public Matrix4f(Matrix4d m1)

  Constructs a new matrix with the same values as the Matrix4d parameter.

  Parameters:
    `m1` - the source matrix

### Matrix4f

    public Matrix4f(Matrix4f m1)

  Constructs a new matrix with the same values as the Matrix4f parameter.

  Parameters:
    `m1` - the source matrix

### Matrix4f

    public Matrix4f(Matrix3f m1,
                    Vector3f t1,
                    float s)

  Constructs and initializes a Matrix4f from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components of the matrix.

  Parameters:
    `m1` - the rotation matrix representing the rotational components
    `t1` - the translational components of the matrix
    `s` - the scale value applied to the rotational components

### Matrix4f

    public Matrix4f()

  Constructs and initializes a Matrix4f to all zeros.

Method Detail

### toString

    public java.lang.String toString()

  Returns a string that contains the values of this Matrix4f.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the String representation

### setIdentity

    public final void setIdentity()

  Sets this Matrix4f to identity.

### setElement

    public final void setElement(int row,
                                 int column,
                                 float value)

  Sets the specified element of this matrix4f to the value provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `column` - the column number to be modified (zero indexed)
    `value` - the new value

### getElement

    public final float getElement(int row,
                                  int column)

  Retrieves the value at the specified row and column of this matrix.

  Parameters:
    `row` - the row number to be retrieved (zero indexed)
    `column` - the column number to be retrieved (zero indexed)
  Returns:
    the value at the indexed element

### getRow

    public final void getRow(int row,
                             Vector4f v)

  Copies the matrix values in the specified row into the vector parameter.

  Parameters:
    `row` - the matrix row
    `v` - the vector into which the matrix row values will be copied

### getRow

    public final void getRow(int row,
                             float[] v)

  Copies the matrix values in the specified row into the array parameter.

  Parameters:
    `row` - the matrix row
    `v` - the array into which the matrix row values will be copied

### getColumn

    public final void getColumn(int column,
                                Vector4f v)

  Copies the matrix values in the specified column into the vector parameter.

  Parameters:
    `column` - the matrix column
    `v` - the vector into which the matrix row values will be copied

### getColumn

    public final void getColumn(int column,
                                float[] v)

  Copies the matrix values in the specified column into the array parameter.

  Parameters:
    `column` - the matrix column
    `v` - the array into which the matrix row values will be copied

### setScale

    public final void setScale(float scale)

  Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.

  Parameters:
    `scale` - the new scale amount

### get

    public final void get(Matrix3d m1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3d parameter.

  Parameters:
    `m1` - matrix into which the rotational component is placed

### get

    public final void get(Matrix3f m1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3f parameter.

  Parameters:
    `m1` - matrix into which the rotational component is placed

### get

    public final float get(Matrix3f m1,
                           Vector3f t1)

  Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale. None of the matrix values are modified.

  Parameters:
    `m1` - the normalized matrix representing the rotation
    `t1` - the translation component
  Returns:
    the scale component of this transform

### get

    public final void get(Quat4f q1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Quat4f parameter.

  Parameters:
    `q1` - quaternion into which the rotation component is placed

### get

    public final void get(Vector3f trans)

  Retrieves the translational components of this matrix.

  Parameters:
    `trans` - the vector that will receive the translational component

### getRotationScale

    public final void getRotationScale(Matrix3f m1)

  Gets the upper 3x3 values of this matrix and places them into the matrix m1.

  Parameters:
    `m1` - the matrix that will hold the values

### getScale

    public final float getScale()

  Performs an SVD normalization of this matrix to calculate and return the uniform scale factor. If the matrix has non-uniform scale factors, the largest of the x, y, and z scale factors will be returned. This matrix is not modified.

  Returns:
    the scale factor of this matrix

### setRotationScale

    public final void setRotationScale(Matrix3f m1)

  Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.

  Parameters:
    `m1` - the matrix that will be the new upper 3x3

### setRow

    public final void setRow(int row,
                             float x,
                             float y,
                             float z,
                             float w)

  Sets the specified row of this matrix4f to the four values provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `x` - the first column element
    `y` - the second column element
    `z` - the third column element
    `w` - the fourth column element

### setRow

    public final void setRow(int row,
                             Vector4f v)

  Sets the specified row of this matrix4f to the Vector provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setRow

    public final void setRow(int row,
                             float[] v)

  Sets the specified row of this matrix4f to the four values provided in the passed array.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setColumn

    public final void setColumn(int column,
                                float x,
                                float y,
                                float z,
                                float w)

  Sets the specified column of this matrix4f to the four values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `x` - the first row element
    `y` - the second row element
    `z` - the third row element
    `w` - the fourth row element

### setColumn

    public final void setColumn(int column,
                                Vector4f v)

  Sets the specified column of this matrix4f to the vector provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### setColumn

    public final void setColumn(int column,
                                float[] v)

  Sets the specified column of this matrix4f to the four values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### add

    public final void add(float scalar)

  Adds a scalar to each component of this matrix.

  Parameters:
    `scalar` - the scalar adder

### add

    public final void add(float scalar,
                          Matrix4f m1)

  Adds a scalar to each component of the matrix m1 and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - the scalar adder
    `m1` - the original matrix values

### add

    public final void add(Matrix4f m1,
                          Matrix4f m2)

  Sets the value of this matrix to the matrix sum of matrices m1 and m2.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### add

    public final void add(Matrix4f m1)

  Sets the value of this matrix to the sum of itself and matrix m1.

  Parameters:
    `m1` - the other matrix

### sub

    public final void sub(Matrix4f m1,
                          Matrix4f m2)

  Performs an element-by-element subtraction of matrix m2 from matrix m1 and places the result into matrix this (this = m2 - m1).

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### sub

    public final void sub(Matrix4f m1)

  Sets this matrix to the matrix difference of itself and matrix m1 (this = this - m1).

  Parameters:
    `m1` - the other matrix

### transpose

    public final void transpose()

  Sets the value of this matrix to its transpose in place.

### transpose

    public final void transpose(Matrix4f m1)

  Sets the value of this matrix to the transpose of the argument matrix.

  Parameters:
    `m1` - the matrix to be transposed

### set

    public final void set(Quat4f q1)

  Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### set

    public final void set(AxisAngle4f a1)

  Sets the value of this matrix to the matrix conversion of the (single precision) axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(Quat4d q1)

  Sets the value of this matrix to the matrix conversion of the double precision quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### set

    public final void set(AxisAngle4d a1)

  Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(Quat4d q1,
                          Vector3d t1,
                          double s)

  Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.

  Parameters:
    `q1` - the rotation expressed as a quaternion
    `t1` - the translation
    `s` - the scale value

### set

    public final void set(Quat4f q1,
                          Vector3f t1,
                          float s)

  Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.

  Parameters:
    `q1` - the rotation expressed as a quaternion
    `t1` - the translation
    `s` - the scale value

### set

    public final void set(Matrix4d m1)

  Sets the value of this matrix to the float value of the passed matrix4d m1.

  Parameters:
    `m1` - the matrix4d to be converted to float

### set

    public final void set(Matrix4f m1)

  Sets the value of this matrix to a copy of the passed matrix m1.

  Parameters:
    `m1` - the matrix to be copied

### invert

    public final void invert(Matrix4f m1)

  Sets the value of this matrix to the matrix inverse of the passed (user declared) matrix m1.

  Parameters:
    `m1` - the matrix to be inverted

### invert

    public final void invert()

  Inverts this matrix in place.

### determinant

    public final float determinant()

  Computes the determinate of this matrix.

  Returns:
    the determinate of the matrix

### set

    public final void set(Matrix3f m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).

  Parameters:
    `m1` - the single-precision 3x3 matrix

### set

    public final void set(Matrix3d m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are initialized as if this were an identity matrix (i.e., affine matrix with no translational component).

  Parameters:
    `m1` - the double-precision 3x3 matrix

### set

    public final void set(float scale)

  Sets the value of this matrix to a scale matrix with the the passed scale amount.

  Parameters:
    `scale` - the scale factor for the matrix

### set

    public final void set(float[] m)

  Sets the values in this Matrix4f equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).

  Parameters:
    `m` - the single precision array of length 16

### set

    public final void set(Vector3f v1)

  Sets the value of this matrix to a translate matrix with the passed translation value.

  Parameters:
    `v1` - the translation amount

### set

    public final void set(float scale,
                          Vector3f t1)

  Sets the value of this transform to a scale and translation matrix; the scale is not applied to the translation and all of the matrix values are modified.

  Parameters:
    `scale` - the scale factor for the matrix
    `t1` - the translation amount

### set

    public final void set(Vector3f t1,
                          float scale)

  Sets the value of this transform to a scale and translation matrix; the translation is scaled by the scale factor and all of the matrix values are modified.

  Parameters:
    `t1` - the translation amount
    `scale` - the scale factor for the matrix

### set

    public final void set(Matrix3f m1,
                          Vector3f t1,
                          float scale)

  Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor. The translation is not modified by the scale.

  Parameters:
    `m1` - the rotation component
    `t1` - the translation component
    `scale` - the scale component

### set

    public final void set(Matrix3d m1,
                          Vector3d t1,
                          double scale)

  Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale factor. The translation is not modified by the scale.

  Parameters:
    `m1` - the rotation component
    `t1` - the translation component
    `scale` - the scale factor

### setTranslation

    public final void setTranslation(Vector3f trans)

  Modifies the translational components of this matrix to the values of the Vector3f argument; the other values of this matrix are not modified.

  Parameters:
    `trans` - the translational component

### rotX

    public final void rotX(float angle)

  Sets the value of this matrix to a counter clockwise rotation about the x axis.

  Parameters:
    `angle` - the angle to rotate about the X axis in radians

### rotY

    public final void rotY(float angle)

  Sets the value of this matrix to a counter clockwise rotation about the y axis.

  Parameters:
    `angle` - the angle to rotate about the Y axis in radians

### rotZ

    public final void rotZ(float angle)

  Sets the value of this matrix to a counter clockwise rotation about the z axis.

  Parameters:
    `angle` - the angle to rotate about the Z axis in radians

### mul

    public final void mul(float scalar)

  Multiplies each element of this matrix by a scalar.

  Parameters:
    `scalar` - the scalar multiplier.

### mul

    public final void mul(float scalar,
                          Matrix4f m1)

  Multiplies each element of matrix m1 by a scalar and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - the scalar multiplier.
    `m1` - the original matrix.

### mul

    public final void mul(Matrix4f m1)

  Sets the value of this matrix to the result of multiplying itself with matrix m1.

  Parameters:
    `m1` - the other matrix

### mul

    public final void mul(Matrix4f m1,
                          Matrix4f m2)

  Sets the value of this matrix to the result of multiplying the two argument matrices together.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### mulTransposeBoth

    public final void mulTransposeBoth(Matrix4f m1,
                                       Matrix4f m2)

  Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - the matrix on the left hand side of the multiplication
    `m2` - the matrix on the right hand side of the multiplication

### mulTransposeRight

    public final void mulTransposeRight(Matrix4f m1,
                                        Matrix4f m2)

  Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - the matrix on the left hand side of the multiplication
    `m2` - the matrix on the right hand side of the multiplication

### mulTransposeLeft

    public final void mulTransposeLeft(Matrix4f m1,
                                       Matrix4f m2)

  Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.

  Parameters:
    `m1` - the matrix on the left hand side of the multiplication
    `m2` - the matrix on the right hand side of the multiplication

### equals

    public boolean equals(Matrix4f m1)

  Returns true if all of the data members of Matrix4f m1 are equal to the corresponding data members in this Matrix4f.

  Parameters:
    `m1` - the matrix with which the comparison is made.
  Returns:
    true or false

### equals

    public boolean equals(java.lang.Object t1)

  Returns true if the Object t1 is of type Matrix4f and all of the data members of t1 are equal to the corresponding data members in this Matrix4f.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `t1` - the matrix with which the comparison is made.
  Returns:
    true or false

### epsilonEquals

    public boolean epsilonEquals(Matrix4f m1,
                                 float epsilon)

  Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false. The L-infinite distance is equal to MAX[i=0,1,2,3 ; j=0,1,2,3 ; abs(this.m(i,j) - m1.m(i,j)]

  Parameters:
    `m1` - the matrix to be compared to this matrix
    `epsilon` - the threshold value

### hashCode

    public int hashCode()

  Returns a hash code value based on the data values in this object. Two different Matrix4f objects with identical data values (i.e., Matrix4f.equals returns true) will return the same hash code value. Two objects with different data members may return the same hash value, although this is not likely.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    the integer hash code value

### transform

    public final void transform(Tuple4f vec,
                                Tuple4f vecOut)

  Transform the vector vec using this Matrix4f and place the result into vecOut.

  Parameters:
    `vec` - the single precision vector to be transformed
    `vecOut` - the vector into which the transformed values are placed

### transform

    public final void transform(Tuple4f vec)

  Transform the vector vec using this Transform and place the result back into vec.

  Parameters:
    `vec` - the single precision vector to be transformed

### transform

    public final void transform(Point3f point,
                                Point3f pointOut)

  Transforms the point parameter with this Matrix4f and places the result into pointOut. The fourth element of the point input paramter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.
    `pointOut` - the transformed point

### transform

    public final void transform(Point3f point)

  Transforms the point parameter with this Matrix4f and places the result back into point. The fourth element of the point input paramter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.

### transform

    public final void transform(Vector3f normal,
                                Vector3f normalOut)

  Transforms the normal parameter by this Matrix4f and places the value into normalOut. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.
    `normalOut` - the transformed normal

### transform

    public final void transform(Vector3f normal)

  Transforms the normal parameter by this transform and places the value back into normal. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.

### setRotation

    public final void setRotation(Matrix3d m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.

  Parameters:
    `m1` - double precision 3x3 matrix

### setRotation

    public final void setRotation(Matrix3f m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.

  Parameters:
    `m1` - single precision 3x3 matrix

### setRotation

    public final void setRotation(Quat4f q1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.

  Parameters:
    `q1` - the quaternion that specifies the rotation

### setRotation

    public final void setRotation(Quat4d q1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.

  Parameters:
    `q1` - the quaternion that specifies the rotation

### setRotation

    public final void setRotation(AxisAngle4f a1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the axis-angle argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the axis-angle, and then the scale is reapplied to the rotational components.

  Parameters:
    `a1` - the axis-angle to be converted (x, y, z, angle)

### setZero

    public final void setZero()

  Sets this matrix to all zeros.

### negate

    public final void negate()

  Negates the value of this matrix: this = -this.

### negate

    public final void negate(Matrix4f m1)

  Sets the value of this matrix equal to the negation of of the Matrix4f parameter.

  Parameters:
    `m1` - the source matrix

### clone

    public java.lang.Object clone()

  Creates a new object of the same class as this object.

  Overrides:
    `clone` in class `java.lang.Object`
  Returns:
    a clone of this instance.
  Throws:
    `java.lang.OutOfMemoryError` - if there is not enough memory.
  Since:
    vecmath 1.3
  See Also:
    `Cloneable`

### getM00

    public final float getM00()

  Get the first matrix element in the first row.

  Returns:
    Returns the m00.
  Since:
    vecmath 1.5

### setM00

    public final void setM00(float m00)

  Set the first matrix element in the first row.

  Parameters:
    `m00` - The m00 to set.
  Since:
    vecmath 1.5

### getM01

    public final float getM01()

  Get the second matrix element in the first row.

  Returns:
    Returns the m01.
  Since:
    vecmath 1.5

### setM01

    public final void setM01(float m01)

  Set the second matrix element in the first row.

  Parameters:
    `m01` - The m01 to set.
  Since:
    vecmath 1.5

### getM02

    public final float getM02()

  Get the third matrix element in the first row.

  Returns:
    Returns the m02.
  Since:
    vecmath 1.5

### setM02

    public final void setM02(float m02)

  Set the third matrix element in the first row.

  Parameters:
    `m02` - The m02 to set.
  Since:
    vecmath 1.5

### getM10

    public final float getM10()

  Get first matrix element in the second row.

  Returns:
    Returns the m10.
  Since:
    vecmath 1.5

### setM10

    public final void setM10(float m10)

  Set first matrix element in the second row.

  Parameters:
    `m10` - The m10 to set.
  Since:
    vecmath 1.5

### getM11

    public final float getM11()

  Get second matrix element in the second row.

  Returns:
    Returns the m11.
  Since:
    vecmath 1.5

### setM11

    public final void setM11(float m11)

  Set the second matrix element in the second row.

  Parameters:
    `m11` - The m11 to set.
  Since:
    vecmath 1.5

### getM12

    public final float getM12()

  Get the third matrix element in the second row.

  Returns:
    Returns the m12.
  Since:
    vecmath 1.5

### setM12

    public final void setM12(float m12)

  Set the third matrix element in the second row.

  Parameters:
    `m12` - The m12 to set.
  Since:
    vecmath 1.5

### getM20

    public final float getM20()

  Get the first matrix element in the third row.

  Returns:
    Returns the m20.
  Since:
    vecmath 1.5

### setM20

    public final void setM20(float m20)

  Set the first matrix element in the third row.

  Parameters:
    `m20` - The m20 to set.
  Since:
    vecmath 1.5

### getM21

    public final float getM21()

  Get the second matrix element in the third row.

  Returns:
    Returns the m21.
  Since:
    vecmath 1.5

### setM21

    public final void setM21(float m21)

  Set the second matrix element in the third row.

  Parameters:
    `m21` - The m21 to set.
  Since:
    vecmath 1.5

### getM22

    public final float getM22()

  Get the third matrix element in the third row.

  Returns:
    Returns the m22.
  Since:
    vecmath 1.5

### setM22

    public final void setM22(float m22)

  Set the third matrix element in the third row.

  Parameters:
    `m22` - The m22 to set.
  Since:
    vecmath 1.5

### getM03

    public final float getM03()

  Get the fourth element of the first row.

  Returns:
    Returns the m03.
  Since:
    vecmath 1.5

### setM03

    public final void setM03(float m03)

  Set the fourth element of the first row.

  Parameters:
    `m03` - The m03 to set.
  Since:
    vecmath 1.5

### getM13

    public final float getM13()

  Get the fourth element of the second row.

  Returns:
    Returns the m13.
  Since:
    vecmath 1.5

### setM13

    public final void setM13(float m13)

  Set the fourth element of the second row.

  Parameters:
    `m13` - The m13 to set.
  Since:
    vecmath 1.5

### getM23

    public final float getM23()

  Get the fourth element of the third row.

  Returns:
    Returns the m23.
  Since:
    vecmath 1.5

### setM23

    public final void setM23(float m23)

  Set the fourth element of the third row.

  Parameters:
    `m23` - The m23 to set.
  Since:
    vecmath 1.5

### getM30

    public final float getM30()

  Get the first element of the fourth row.

  Returns:
    Returns the m30.
  Since:
    vecmath 1.5

### setM30

    public final void setM30(float m30)

  Set the first element of the fourth row.

  Parameters:
    `m30` - The m30 to set.
  Since:
    vecmath 1.5

### getM31

    public final float getM31()

  Get the second element of the fourth row.

  Returns:
    Returns the m31.
  Since:
    vecmath 1.5

### setM31

    public final void setM31(float m31)

  Set the second element of the fourth row.

  Parameters:
    `m31` - The m31 to set.
  Since:
    vecmath 1.5

### getM32

    public final float getM32()

  Get the third element of the fourth row.

  Returns:
    Returns the m32.
  Since:
    vecmath 1.5

### setM32

    public final void setM32(float m32)

  Set the third element of the fourth row.

  Parameters:
    `m32` - The m32 to set.
  Since:
    vecmath 1.5

### getM33

    public final float getM33()

  Get the fourth element of the fourth row.

  Returns:
    Returns the m33.
  Since:
    vecmath 1.5

### setM33

    public final void setM33(float m33)

  Set the fourth element of the fourth row.

  Parameters:
    `m33` - The m33 to set.
  Since:
    vecmath 1.5

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 1996-2008 Sun Microsystems, Inc. All Rights Reserved. Use is subject to license terms.